"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseJsonStream = exports.parseJsonBuffer = void 0;
const concatStream = require("concat-stream");
const stripBom = require("strip-bom");
function parseJsonBuffer(buffer, deferred) {
    try {
        deferred.resolve(JSON.parse(stripBom(buffer.toString())));
    }
    catch (err) {
        deferred.reject(err);
    }
}
exports.parseJsonBuffer = parseJsonBuffer;
function parseJsonStream(stream, deferred) {
    stream.pipe(concatStream((buffer) => parseJsonBuffer(buffer, deferred)));
}
exports.parseJsonStream = parseJsonStream;
//# sourceMappingURL=parseJson.js.map