"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rx = __importStar(require("rxjs"));
const operators_1 = require("rxjs/operators");
const formatWarn_1 = __importDefault(require("./utils/formatWarn"));
const prettyMilliseconds = require("pretty-ms");
exports.default = (requestRetry$) => {
    return requestRetry$.pipe(operators_1.map((log) => {
        const retriesLeft = log.maxRetries - log.attempt + 1;
        const errorCode = log.error['httpStatusCode'] || log.error['status'] || log.error['errno'] || log.error['code'];
        // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
        const msg = `${log.method} ${log.url} error (${errorCode}). \
Will retry in ${prettyMilliseconds(log.timeout, { verbose: true })}. \
${retriesLeft} retries left.`;
        return Rx.of({ msg: formatWarn_1.default(msg) });
    }));
};
//# sourceMappingURL=reportRequestRetry.js.map